#ifndef SUDOKUCELL_H_
#define SUDOKUCELL_H_

#include <FL/Fl_Widget.H>

class SudokuCell : public Fl_Widget
{
  bool	readonly_;
  int		value_;
  int		hints_[9+1]; 
  int   uniquehint_;	
  int		solvetests_[9+1]; //PLJ improved for all values on fixed place
	
public:
  SudokuCell(int X, int Y, int W, int H);
  //virtual ~SudokuCell();

  char   myI, myJ;  //to remember its own place in the grid for focus feedback
  void  init(int x, int y);//plj remember own position in the grid in myI, myJ
  		
  void	draw();
  int		handle(int event);
  
  //access to internal values
  void	readonlySet(bool r) { readonly_ = r; }//redraw();
  bool	readonlyGet() const { return readonly_; }

  void	valueSet(int v)
        {
		      value_ = v;
          for (int i = 0; i <= 9; i ++)   //TODO do we want to remove the hints? or just keep them for roll back?
            hints_[i] = 0;
          //TODO redraw(); to much redraws?
		    }		    
  int		valueGet() const { return value_; }
  
  void	hintsSet(int v) { hints_[v] = v;  }//TODO redraw(); toTODOtodo to much redraws??
  int		hintsGet(int n) const { return hints_[n]; }
  char	hintsGetChar(int n); 
  void	hintsRemove(int v) { hints_[v] = 0; }
  void  resetHints() 
        { 
         	for (int i = 0; i <= 9; i ++) 
         	{
         		hints_[i] = 0; 
         	}
          uniquehint_ = 0;
          //redraw();
        }
           
  void  uniquehintSet(int v)
  { 
  	uniquehint_ = v; 
  	//redraw(); 
  }
  int   uniquehintGet(){ return uniquehint_; }            
        
  void  printCell();
};

/* * /
char* sdkcll_names[] = {	// FLTK events names
"FL_NO_EVENT",
"FL_PUSH",
"FL_RELEASE",
"FL_ENTER",
"FL_LEAVE",
"FL_DRAG",
"FL_FOCUS",
"FL_UNFOCUS",
"FL_KEYDOWN",
"FL_KEYUP",
"FL_CLOSE",
"FL_MOVE",
"FL_SHORTCUT",
"FL_DEACTIVATE",
"FL_ACTIVATE",
"FL_HIDE",
"FL_SHOW",
"FL_PASTE",
"FL_SELECTIONCLEAR",
"FL_MOUSEWHEEL",
"FL_DND_ENTER",
"FL_DND_DRAG",
"FL_DND_LEAVE",
"FL_DND_RELEASE"
};
/ * */
#endif /*SUDOKUCELL_H_*/
